; #########################################################################

;     include files
;     ~~~~~~~~~~~~~
      include WINDOWS.INC
      include masm32.inc
      include gdi32.inc
      include user32.inc
      include kernel32.inc
      include comctl32.inc
      include comdlg32.inc
      include shell32.inc
      include oleaut32.inc
      include msimg32.inc
;      include \Masm32\PrgFil\RadASM\Masm\inc\debug.inc
      include Objects.inc

;     libraries
;     ~~~~~~~~~
      includelib masm32.lib
      includelib gdi32.lib
      includelib user32.lib
      includelib kernel32.lib
      includelib comctl32.lib
      includelib comdlg32.lib
      includelib shell32.lib
      includelib oleaut32.lib
      includelib msimg32.lib
;      includelib \Masm32\PrgFil\RadASM\Masm\lib\debug.lib

;--------------------------------------------------------------------------------
;If you are doing source code breakpoints, this file must be included.
;You don't need it with int 3 breakpoints.
include \masm32\PrgFil\radasm\masm\inc\radbg.inc
;--------------------------------------------------------------------------------

DBGWIN_DEBUG_ON = 1 ;turn it off if you don't want to include debug info into the program
DBGWIN_EXT_INFO = 1 ;turn it off if you don't want to include extra debug info into the program

; #########################################################################

        ;=================
        ; Local prototypes
        ;=================
        WinMain          PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
        TopXY            PROTO :DWORD,:DWORD
        Paint_Proc       PROTO :DWORD
        RegisterWinClass PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        MsgLoop          PROTO
        Main             PROTO

        wsprintfA PROTO C :DWORD,:VARARG
        wsprintf equ <wsprintfA>

      ;=============
      ; Local macros
      ;=============

      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM

    ; -------------------------
    ; initialised GLOBAL value
    ; -------------------------
      IGLOBAL MACRO variable:VARARG
      .data
        variable
      .code
      ENDM

    ; --------------------------------
    ; initialised GLOBAL string value
    ; --------------------------------
      STRING MACRO variable:REQ,args:VARARG
      .data
        variable db args,0
      .code
      ENDM

    ; ---------------------
    ; literal string MACRO
    ; ---------------------
      literal MACRO quoted_text:VARARG
        LOCAL local_text
        .data
          local_text db quoted_text,0
        .code
        EXITM <local_text>
      ENDM
    ; --------------------------------
    ; string address in INVOKE format
    ; --------------------------------
      SADD MACRO quoted_text:VARARG
        EXITM <ADDR literal(quoted_text)>
      ENDM
    ; --------------------------------
    ; string OFFSET for manual coding
    ; --------------------------------
      CTXT MACRO quoted_text:VARARG
        EXITM <offset literal(quoted_text)>
      ENDM

      ShellAboutBox MACRO handle,IconHandle,quoted_Text_1,quoted_Text_2:VARARG
        LOCAL AboutTitle,AboutMsg,buffer
          .data
            AboutTitle db quoted_Text_1,0
            AboutMsg   db quoted_Text_2,0
            buffer db 128 dup (0)
          .code
        mov esi, offset AboutTitle
        mov edi, offset buffer
        mov ecx, lengthof AboutTitle
        rep movsb
        invoke ShellAbout,handle,ADDR buffer,ADDR AboutMsg,IconHandle
      ENDM

      AppModel MACRO Processor
        Processor             ;; Processor type
        .model flat, stdcall  ;; 32 bit memory model
        option casemap :none  ;; case sensitive
      ENDM

      DisplayMenu MACRO handl, IDnum
        invoke LoadMenu,hInstance,IDnum
        invoke SetMenu,handl,eax
      ENDM

      DisplayWindow MACRO handl, ShowStyle
        invoke ShowWindow,handl, ShowStyle
        invoke UpdateWindow,handl
      ENDM

      AutoScale MACRO swidth, sheight
        invoke GetPercent,sWid,swidth
        mov Wwd, eax
        invoke GetPercent,sHgt,sheight
        mov Wht, eax

        invoke TopXY,Wwd,sWid
        mov Wtx, eax

        invoke TopXY,Wht,sHgt
        mov Wty, eax
      ENDM

      GLOBAL MACRO var1,var2,var3,var4,var5,var6,var7,var8,var9,var0,
                   varA,varB,varC,varD,varE,varF,varG,varH,varI,varJ
        .data?
          var1
          var2
          var3
          var4
          var5
          var6
          var7
          var8
          var9
          var0
          varA
          varB
          varC
          varD
          varE
          varF
          varG
          varH
          varI
          varJ
        .code
      ENDM

    ; --------------------------------------------
    ;   
    ; --------------------------------------------
    HIWORD  MACRO   bigword ;; Retrieves the high word from double word argument

    mov ebx,bigword
    shr ebx,16      ;; Shift 16 for high word to set to high word
                
    ENDM

    ; ------------------------------------------------
    ;   
    ; ------------------------------------------------
      LOWORD MACRO bigword  
        mov  eax,bigword
        and  eax,0FFFFh     ; Set to low word 
      ENDM
      
    ; ---------------------------------------------------------------------------
    ;        -        ;
    ; hMenu -                         ;
    ; Ch_Un -    (  )           ;
    ; IDMenu - <1300, 1302, 1304>   (  - )  ;
    ; ---------------------------------------------------------------------------
    
      CheckMIGroup MACRO hMenu, Ch_Un, IDMenu
        IRP ID, <IDMenu>
          invoke CheckMenuItem, hMenu, ID,Ch_Un or MF_BYCOMMAND
        ENDM
      ENDM      

MENUITEM STRUCT
      cdSize    dd ?
      wID       dd ?  ;menu id
      hIcon     dd ?  ;handle to an icon
      dwStyle   dd ?  ;style
      lpString  dd ?  ;string to show
      len       dd ?
MENUITEM ENDS

    .data
        szDisplayName db "MenuXP",0
        szPopup1 db "&File",0
        szPopup2 db "&Edit",0
        szPopup3 db "&View",0
        szPopup4 db "&Help",0
                
        szNew db "&New",0
        szOpen db "&Open...",0
        szSave db "&Save",0
        szSaveAs db "Save &As...",0
        szPrint db "&Print...",0
        szPrintPreview db "Print Pre&view",0
        szExit db "E&xit",0
        szUndo db "&Undo",0
        szCut db "Cu&t",0
        szCopy db "&Copy",0
        szPaste db "&Paste",0
        szDeletePaste db "&Delete",0        
        szToolbars db "Toolbars",0
        szStandard db "Standard",0
        szCustomize db "Customize...",0
        szSatatusBar db "&Satatus Bar",0 
        szAbout db "&About MenuSkins...",0

    .data?
        hInstance HINSTANCE ?
        CommandLine dd ?
        hIcon HICON ?
        hCursor HCURSOR ?
        sWid dd ?
        sHgt dd ?
        hWnd HANDLE ?
        hMenu HMENU ?
        hObjectMenu dd ?
        hMenuPopup1 HMENU ?
        hMenuPopup2 HMENU ?
        hMenuPopup3 HMENU ?
        hMenuPopup4 HMENU ?
        hMenuPopup5 HMENU ?
        mpi1 MENUITEM <?>
        mpi2 MENUITEM <?>
        mpi3 MENUITEM <?>
        mpi4 MENUITEM <?>
        
        mi1 MENUITEM <?>
        mi2 MENUITEM <?>
        mi3 MENUITEM <?>
        mi4 MENUITEM <?>
        mi5 MENUITEM <?>
        mi6 MENUITEM <?>
        mi7 MENUITEM <?>
        mi8 MENUITEM <?>
        mi9 MENUITEM <?>
        mi10 MENUITEM <?>
        mi11 MENUITEM <?>
        mi12 MENUITEM <?>
        mi13 MENUITEM <?>
        mi14 MENUITEM <?>
        mi15 MENUITEM <?>
        mi16 MENUITEM <?>
        mi17 MENUITEM <?>
        mi18 MENUITEM <?>
        mi19 MENUITEM <?>
        mi20 MENUITEM <?>
        mi21 MENUITEM <?>                           
        hImageList HIMAGELIST ?

    .const
        
        ID_FILE_NEW     equ 1000                        
        ID_FILE_OPEN    equ 1002
        ID_FILE_SAVE    equ 1004
        ID_FILE_SAVE_AS equ 1006
        ID_FILE_PRINT   equ 1008
        ID_FILE_PRINT_PREVIEW   equ 1010    
        ID_APP_EXIT     equ 1014
        ID_EDIT_UNDO    equ 1016
        ID_EDIT_CUT     equ 1018
        ID_EDIT_COPY    equ 1020
        ID_EDIT_PASTE   equ 1022
        ID_EDIT_DELETE  equ 1034
        ID_APP_ABOUT    equ 1024
        ID_VIEW_STANDARD equ 1026
        ID_VIEW_CUSTOMIZE equ 1028
        ID_VIEW_STATUSBAR equ 1030
        ID_VIEW_TOOLBARS equ 1032
        ID_FILE_SEP1    equ 1050
        ID_FILE_SEP2    equ 1052
        ID_POPUP1       equ 1060
        ID_POPUP2       equ 1062        
        ID_POPUP3       equ 1064        
        ID_POPUP4       equ 1066        
        
        ID_BMP1         equ 100     
        
; ########################### Inserted modules ############################
      include \masm32\MACROS\Macros.asm
      include TMenu.asm

; #########################################################################

